package com.steerinfo.meterwork.meterworkbeltscaleactual.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkbeltscaleactual.model.MeterWorkBeltScaleActual;
import com.steerinfo.meterwork.meterworkbeltscaleactual.service.IMeterWorkBeltScaleActualService;
import com.steerinfo.pretrack.prebeltscale.model.PreBeltScale;
import com.steerinfo.pretrack.prebeltscale.service.IPreBeltScaleService;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * MeterWorkBeltScaleActual RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-16 02:25
 * 类描述
 * 修订历史：
 * 日期：2021-10-16
 * 作者：generator
 * 参考：
 * 描述：MeterWorkBeltScaleActual RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkbeltscaleactuals")
public class MeterWorkBeltScaleActualController extends BaseRESTfulController {

    @Autowired
    IMeterWorkBeltScaleActualService meterWorkBeltScaleActualService;

    @Autowired
    IPreBeltScaleService preBeltScaleService;

    PreBeltScale forcast =new PreBeltScale();

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkbeltscaleactual:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkBeltScaleActual> list = meterWorkBeltScaleActualService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkbeltscaleactual:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkBeltScaleActual> list = meterWorkBeltScaleActualService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkBeltScaleActual对象创建")
    @ApiImplicitParam(name = "meterWorkBeltScaleActual", value = "详细实体meterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    //@RequiresPermissions("meterworkbeltscaleactual:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkBeltScaleActual model){
        MeterWorkBeltScaleActual meterWorkBeltScaleActual = meterWorkBeltScaleActualService.add(model);
        return success(meterWorkBeltScaleActual);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkbeltscaleactual:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkBeltScaleActual meterWorkBeltScaleActual = meterWorkBeltScaleActualService.getById(id);
        return success(meterWorkBeltScaleActual);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkBeltScaleActual信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkBeltScaleActual", value = "详细实体meterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    })
    //@RequiresPermissions("meterworkbeltscaleactual:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkBeltScaleActual model){
        model.setId(id);
        MeterWorkBeltScaleActual meterWorkBeltScaleActual = meterWorkBeltScaleActualService.modify(model);
        return success(meterWorkBeltScaleActual);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkbeltscaleactual:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkBeltScaleActualService.delete(ids);
    	}
      return success();
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    //@RequiresPermissions("meterworkstorageactual:create")
    @PostMapping(value = "/doAddBeltScaleActual")
    public RESTfulResult doAddBeltScaleActual(@RequestBody MeterWorkBeltScaleActual model) {
        RESTfulResult rm = failed();
        try {
            CommonPage<PreBeltScale> preBeltScale = new CommonPage<PreBeltScale>();
            PreBeltScale s = new PreBeltScale();
            s.setValueFlag("8");
            s.setPredictionNo(model.getPredictionNo());
            preBeltScale.setParam(s);
            List<PreBeltScale> scaleList = preBeltScaleService.doQueryLikeInfo(preBeltScale);
            if(scaleList.size()==0){
                return failed("操作失败! 未查询到该预报");
            }
            model.setShipNo(scaleList.get(0).getShipNo());//船号
            model.setForwardingWeight(scaleList.get(0).getForwardingWeight());//发运重量
            model.setUnloadWharf(scaleList.get(0).getUnloadWharf());//卸货码头
            model.setOverstock(scaleList.get(0).getOverstock());//压港时间
            model.setUnloadSite(scaleList.get(0).getUnloadSite());//起运港
            model.setOrderNo((scaleList.get(0).getOrderNo()));//合同号
            model.setNewGg(scaleList.get(0).getNewGg());//规格
            model.setNewHlh(scaleList.get(0).getNewHlh());//海轮号
            int str =  meterWorkBeltScaleActualService.doAddBeltScaleActual(model);
            if (str>0&&"1".equals(model.getHeatNo())) {//自定义炉号为1时是开始计量的创建  修改预报状态
                forcast.setPredictionNo(model.getPredictionNo());
                forcast.setValueFlag("2");//使用中
                forcast.setStartTime(new Date());//开卸时间
                if(preBeltScaleService.updateScalePrediction(forcast)>0){
                    return success(str);
                }else {
                    return failed("操作失败!" +"预报状态修改为2失败");
                }
            } else if(str>0){
                return success(str);
            }else{
                return failed("操作失败!");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    //@RequiresPermissions("meterworkstorageactual:create")
    @PostMapping(value = "/updateBeltScaleActual")
    public RESTfulResult updateBeltScaleActual(@RequestBody MeterWorkBeltScaleActual model) {
        RESTfulResult rm = failed();
        try {

            int  str= meterWorkBeltScaleActualService.updateBeltScaleActual(model);
            if (str>0) {
                return success(str);
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    //@RequiresPermissions("meterworkstorageactual:create")
    @PostMapping(value = "/endMeter")
    public RESTfulResult endMeter(@RequestBody MeterWorkBeltScaleActual model) {
        RESTfulResult rm = failed();
        try {
            model.setEndTime(new Date());
            model.setNetWeight(model.getEndWeight().subtract(model.getStartWeight()));
            int str =  meterWorkBeltScaleActualService.updateBeltScaleActual(model);
            if (str>0) {
                MeterWorkBeltScaleActual actual = new MeterWorkBeltScaleActual();
                actual.setPredictionNo(model.getPredictionNo());
                actual.setValueFlag("1");
                List<MeterWorkBeltScaleActual>  list = meterWorkBeltScaleActualService.doQueryActualInfoFlags(actual);//查询当前有效的实绩
                boolean flag = false;
                if(list.size()==2){
                    if("A".equals(list.get(0).getScaleName())&&list.get(0).getEndWeight()!=null){
                        if("B".equals(list.get(1).getScaleName())&&list.get(1).getEndWeight()!=null){
                            flag = true;
                        }
                    }
                    if("B".equals(list.get(0).getScaleName())&&list.get(0).getEndWeight()!=null){
                        if("A".equals(list.get(1).getScaleName())&&list.get(1).getEndWeight()!=null){
                            flag = true;
                        }
                    }
                }else{
                    flag = false;
                }
                if (flag){
                    forcast.setPredictionNo(model.getPredictionNo());
                    forcast.setValueFlag("3");//使用完成
                    forcast.setUpdateManNo(model.getUpdateManNo());
                    forcast.setUpdateManName(model.getUpdateManName());
                    forcast.setUpdateTime(new Date());
                    if(preBeltScaleService.updateScalePrediction(forcast)>0){
                        return success(str);
                    }else {
                        return failed("操作失败!" +"预报状态修改为3失败");
                    }
                }
                return success(str);
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    ////根据不同的状态查询数据
    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    //@RequiresPermissions("PreBeltScale:create")
    @PostMapping(value = "/doQueryActualInfoFlags")
    public RESTfulResult doQueryActualInfoFlags(@RequestBody MeterWorkBeltScaleActual model) {
        try {
            List<MeterWorkBeltScaleActual> no = meterWorkBeltScaleActualService.doQueryActualInfoFlags(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    ////查最大打印编码
    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    //@RequiresPermissions("PreBeltScale:create")
    @PostMapping(value = "/doQueryMaxPno")
    public RESTfulResult doQueryMaxPno(@RequestBody MeterWorkBeltScaleActual model) {
        try {
            List<MeterWorkBeltScaleActual> no = meterWorkBeltScaleActualService.doQueryMaxPno(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    ////分组查询  统计！
    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    @PostMapping(value = "/doQueryActualInfoAndGroup")
    public RESTfulResult doQueryActualInfoAndGroup(@RequestBody CommonPage<MeterWorkBeltScaleActual> model) {
        try {
            List<MeterWorkBeltScaleActual> no = meterWorkBeltScaleActualService.doQueryActualInfoAndGroup(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    //实绩查询 多条件
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    @PostMapping(value = "/doQueryAndMultiple")
    public RESTfulResult doQueryAndMultiple(@RequestBody CommonPage<MeterWorkBeltScaleActual> model) {
        try {
            List<MeterWorkBeltScaleActual> no = meterWorkBeltScaleActualService.doQueryAndMultiple(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
    //实绩修改状态  有效  无效
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    @PostMapping(value = "/doUpdateFlags")
    public RESTfulResult doUpdateFlags(@RequestBody List<MeterWorkBeltScaleActual> models) {
        RESTfulResult rm = failed();
        int num= 0;
        try {
            if("0".equals(models.get(0).getValueFlag())){
                num = meterWorkBeltScaleActualService.doUpdateFlags_0(models);
            }else if("1".equals(models.get(0).getValueFlag())){
                num = meterWorkBeltScaleActualService.doUpdateFlags_1(models);
            }
            if(num>=1){
                return success(num);
            }else{
                return failed("修改预报状态失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
    //实绩修改审核状态
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterWorkBeltScaleForecast对象创建")
    @ApiImplicitParam(name = "MeterWorkBeltScaleActual", value = "详细实体MeterWorkBeltScaleActual", required = true, dataType = "MeterWorkBeltScaleActual")
    @PostMapping(value = "/doUpdateCheckFlags")
    public RESTfulResult doUpdateCheckFlags(@RequestBody List<MeterWorkBeltScaleActual> models) {
        RESTfulResult rm = failed();
        int num= 0;
        try {
            if("0".equals(models.get(0).getCheckFlag())){
                num = meterWorkBeltScaleActualService.doUpdateCheckFlags_0(models);
            }else if("1".equals(models.get(0).getCheckFlag())){
                num = meterWorkBeltScaleActualService.doUpdateCheckFlags_1(models);
            }
            if(num>=1){
                return success(num);
            }else{
                return failed("修改实绩审核状态失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
